Init-Skirpt für Emacs unter Debian GNU/Linux

Seit Version 23.1 ist es möglich, Emacs als Daemon zu starten, sodass beim Aufrufen eines neuen Emacs-Windows kein neuer Prozess gestartet werden muss. Läuft ein Emacs als Daemon, wird fortan der Editor mittels des Programms emacsclient aufgerufen.

Folgendes Init-Skript startet Emacs als Daemon während des Systemstarts:

#! /bin/sh
### BEGIN INIT INFO
# Provides:          emacs
# Required-Start:    $local_fs
# Required-Stop:     $local_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Description:       This file should be placed in /etc/init.d.
### END INIT INFO

USERNAME=`basename $0 | cut -d"." -f2`
#change this
DESC="Run emacs as daemon for a specified user."
NAME=emacs
#change this
DAEMON=/usr/bin/$NAME
DAEMON_ARGS="--daemon"
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
#change this
EMACSCLIENT=/usr/bin/emacsclient

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
    [ `/bin/pidof emacs` ] || /bin/rm -f ~$USERNAME/.emacs.desktop.lock
	# Return
	#   0 if daemon has been started
	#   1 if daemon was already running
	#   2 if daemon could not be started
	start-stop-daemon --start -d /home/$USERNAME --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
		|| return 1
	start-stop-daemon --start -d /home/$USERNAME --quiet --pidfile $PIDFILE --exec $DAEMON -v --startas /bin/su -- $USERNAME -l -c "$DAEMON $DAEMON_ARGS" \
		|| return 2
	# Add code here, if necessary, that waits for the process to be ready
	# to handle requests from services started subsequently which depend
	# on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
	su $USERNAME -c "$EMACSCLIENT -n --eval '(progn (desktop-save \"~/\") (kill-emacs))'" 
	# Return
	#   0 if daemon has been stopped
	#   1 if daemon was already stopped
	#   2 if daemon could not be stopped
	#   other if a failure occurred
	start-stop-daemon --quiet --retry=TERM/5/KILL/5 --pidfile $PIDFILE --name $NAME --stop 
	RETVAL="$?"
	[ "$RETVAL" = 2 ] && return 2
	# Wait for children to finish too if this is a daemon that forks
	# and if the daemon is only ever run from this initscript.
	# If the above conditions are not satisfied then add some other code
	# that waits for the process to drop all resources that could be
	# needed by services started subsequently.  A last resort is to
	# sleep for some time.
	start-stop-daemon --quiet --oknodo --retry=TERM/5/KILL/5 --exec $DAEMON --stop
	[ "$?" = 2 ] && return 2
	# Many daemons don't delete their pidfiles when they exit.
	rm -f $PIDFILE
	[ -f /home/$USERNAME/.emacs.desktop.lock ] && rm -f /home/$USERNAME/.emacs.desktop.lock
	return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
	#
	# If the daemon can reload its configuration without
	# restarting (for example, when it is sent a SIGHUP),
	# then implement that here.
	#
	start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
	return 0
}

case "$1" in
  start)
	[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
	do_start
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  stop)
	[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
	do_stop
	case "$?" in
		0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
		2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
	esac
	;;
  #reload|force-reload)
	#
	# If do_reload() is not implemented then leave this commented out
	# and leave 'force-reload' as an alias for 'restart'.
	#
	#log_daemon_msg "Reloading $DESC" "$NAME"
	#do_reload
	#log_end_msg $?
	#;;
  restart|force-reload)
	#
	# If the "reload" option is implemented then remove the
	# 'force-reload' alias
	#
	log_daemon_msg "Restarting $DESC" "$NAME"
	do_stop
	case "$?" in
	  0|1)
		do_start
		case "$?" in
			0) log_end_msg 0 ;;
			1) log_end_msg 1 ;; # Old process is still running
			*) log_end_msg 1 ;; # Failed to start
		esac
		;;
	  *)
	  	# Failed to stop
		log_end_msg 1
		;;
	esac
	;;
  *)
	#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
	echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
	exit 3
	;;
esac

Dieses Skript wird unter /etc/init.d/emacs.username gespeichert, wobei username der Systemnutzer ist, unter dem der Daemon laufen soll – sprich: der Nutzer, der Emacs benutzt. Anschließend wird mittels des Befehls update-rc.d emacs.username defaults das Skript in die entsprechenden Runlevel für den Systemstart und -stop eingefügt. Das Skript basiert auf den Überlegungen im Emacswiki.

Einschränkungen: Das Skript geht davon aus, dass sich das Homeverzeichnis des aufrufenden Benutzers unter /home befindet. Liegt es außerhalb (beispielsweise /root für root, muss dies entsprechend in Zeile 46 und 48 angepasst werden.

Kommentar verfassen

Deine E-Mail-Adresse wird nicht veröffentlicht. Erforderliche Felder sind mit * markiert